#include "stm32f10x.h"

#include "SPI_driver.h"
u8 SPIx_ReadWriteByte(u8 TxData);
u8 AD_WaitReady(void); 
void SPI_SetSpeed(u8 SpeedSet);
u8 SPI_ReadWriteByte(u8 TxData);              //SPI߶дһֽ
////////////////////////////////////////////////////////////////////////////////
// SPIģĳʼ룬óģʽSD
////////////////////////////////////////////////////////////////////////////////
/*******************************************************************************
* Function Name  : SPI_Configuration
* Description    : SPIģʼIOڵĳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SPI_Configuration(void)
{
	  SPI_InitTypeDef  SPI_InitStructure;
    GPIO_InitTypeDef GPIO_InitStructure;
	  SystemInit();        
    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA 
                |RCC_APB2Periph_GPIOC | RCC_APB2Periph_AFIO 
                |RCC_APB2Periph_SPI1, ENABLE );

	/* Configure USART1 Rx (PB.8) as input floating  busy busy DRDY */
        GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
        GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
		    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
        GPIO_Init(GPIOC, &GPIO_InitStructure);
	/* Configure SPI1 pins: SCK, MISO and MOSI */
        GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
        GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;  //
        GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
        GPIO_Init(GPIOA, &GPIO_InitStructure);
        
        /* Configure I/O for Flash Chip select */
        GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;  //SPI CS
        GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  //
	    	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
        GPIO_Init(GPIOC, &GPIO_InitStructure);
        
        /* Deselect the FLASH: Chip Select high */
        GPIO_SetBits(GPIOC,GPIO_Pin_5);
        GPIO_SetBits(GPIOC,GPIO_Pin_4);
        
	    	SPI_Cmd(SPI1, DISABLE); //ʹSPI	Լ
		
	/* SPI1 configuration */
        SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;  //SPI˫ģʽ:SPIΪ˫˫ȫ˫
        SPI_InitStructure.SPI_Mode = SPI_Mode_Master;                //SPIģʽ:ΪSPI
        SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;                //SPIݴС:SPIͽ8λ֡ṹ
        SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;                //ѡ˴ʱӵ̬:ʱո
        SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;        //ݲڵڶʱ
        SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;                //NSSźӲNSSܽţʹSSIλ:ڲNSSźSSIλ
        SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_64;                //岨ԤƵֵ:ԤƵֵΪ256
        SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;        //ָݴMSBλLSBλʼ:ݴMSBλʼ
        SPI_InitStructure.SPI_CRCPolynomial = 7;            //CRCֵĶʽ
        SPI_Init(SPI1, &SPI_InitStructure);             //SPI_InitStructָĲʼSPIxĴ
        
        //SPI1->CR1|=1<<6; //SPI豸ʹ
        /* Enable SPI1  */
        SPI_Cmd(SPI1, ENABLE); //ʹSPI
        
        SPI_ReadWriteByte(0xff);//   
}
#if 0
/*******************************************************************************
* Function Name  : SPI_SetSpeed
* Description    : SPIٶΪ
* Input          : u8 SpeedSet 
*                  ٶ0ģʽ0ģʽ
*                  SPI_SPEED_HIGH   1
*                  SPI_SPEED_LOW    0
* Output         : None
* Return         : None
*******************************************************************************/
void SPI_SetSpeed(u8 SpeedSet)
{
    SPI_InitTypeDef SPI_InitStructure;

    SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
    //ٶ0ģʽ0ģʽ
    if(SpeedSet==SPI_SPEED_LOW)
    {
        SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256;
    }
    else
    {
        SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_8;
    }

	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
	SPI_InitStructure.SPI_CRCPolynomial = 7;
	SPI_Init(SPI3, &SPI_InitStructure);
	SPI_ReadWriteByte(0xff);
	SPI_ReadWriteByte(0xff);
  return;
}
#endif

//SPIx дһֽ
//TxData:Ҫдֽ
//ֵ:ȡֽ
u8 SPI_ReadWriteByte(u8 TxData)
{
    u8 RxData = 0;
    
    //ȴͻ
    while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET);
    //һֽ
    SPI_I2S_SendData(SPI1, TxData);

    //ȴݽ
    while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET);
    //ȡ
    RxData = SPI_I2S_ReceiveData(SPI1);

    return (u8)RxData;
}

/*******************************************************************************
* Function Name  : AD_WaitReady
* Description    : ȴAD Ready
* Input          : None
* Output         : None
* Return         : u8 
*                   0 ɹ
*                   otherʧ
*******************************************************************************/
u8 AD_WaitReady(void)
{
    u8 r1;
    u16 retry;
    retry = 0;
    do
    {
        r1 = SPI_ReadWriteByte(0xFF);
        if(retry==0xfffe)
        {
            return 1;
        }
    }while(r1!=0xFF);

    return 0;
}
/*********************************************************************************************************
**                                        End Of File
*********************************************************************************************************/
